# -*- coding: utf-8 -*- #
## Copyright 2020 Google LLC. All Rights Reserved.
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##    http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
release_tracks: [GA, BETA, ALPHA]
help_text:
  brief: Get the IAM policy for the ${singular_name}.
  description: |
    *{command}* displays the IAM policy associated with the ${singular_name}.
    If formatted as JSON,the output can be edited and used as a
    policy file for set-iam-policy. The output includes an "etag" field
    identifying the version emitted and allowing detection of
    concurrent policy updates; see
    $ {parent} set-iam-policy for additional details.
  examples: |
    To print the IAM policy for a given ${singular_name}, run:

      $ {command} my-${singular_name} ${flags}

request:
  collection: ${api_name}.${plural_name}
  use_relative_name: false
  api_version: ${api_version}
  BETA:
    api_version: beta
    modify_request_hooks:
    - googlecloudsdk.command_lib.iam.hooks:UseMaxRequestedPolicyVersion:api_field=optionsRequestedPolicyVersion
  ALPHA:
    api_version: alpha
    modify_request_hooks:
    - googlecloudsdk.command_lib.iam.hooks:UseMaxRequestedPolicyVersion:api_field=optionsRequestedPolicyVersion

arguments:
  resource:
    help_text: The ${singular_name} for which to display the IAM policy.
    spec: !REF googlecloudsdk.command_lib.${api_name}.resources:${singular_name}
